#
# This file is called by /etc/init.d/vdr
#

writewarning ()
{
echo -e \
"#\n"\
"# WARNING: Do not edit this file! It is automatically generated by the\n"\
"#          vdr init-script. If you want to define some custom commands,\n"\
"#          put them in a file called $1.<name>.conf and restart vdr.\n"\
"#          All $1.*.conf files will be concatenated to this file.\n"\
"#\n"\
"# WARNUNG: ndern Sie nicht diese Datei! Diese Datei wird automatisch vom\n"\
"#          vdr init-Skript generiert. Wenn Sie eigene Kommandos definieren\n"\
"#          mchten, so schreiben Sie diese in eine Datei mit dem Namen\n"\
"#          $1.<name>.conf und starten Sie vdr erneut. Alle\n"\
"#          $1.*.conf -Dateien werden zu dieser Datei zusammengefgt.\n"\
"#\n\n\n"
}

# merges single <cmdtype>.<name>.conf files into one <cmdtype>.conf using
# the order defined in order.<cmdtype>.conf
mergecommands ()
{
    local cmd
    local cmds
    local cmdsorder
    local line
    local cmdtype
    local cmdfile
    local ordered_cmds
    
    cmdtype=$1
    cmdfile="$CFG_DIR/$cmdtype.conf"

    writewarning $cmdtype > "$cmdfile"

    cmdsorder=( `cat /etc/vdr/command-hooks/order.$cmdtype.conf | sed "s/#.*$//"` )
    cmds=( `find $CMDHOOKSDIR -maxdepth 1 -name "$cmdtype.*.conf" -printf "%f \n" | sed "s/$cmdtype\.\(.\+\)\.conf/\1/g"` )
    
    # first the ordered commands:
    for cmd in ${cmdsorder[@]}; do
        for (( line=0 ; line<${#cmds[@]} ; line++ )); do
	    if [ "$cmd" == "-${cmds[$line]}" ]; then
		unset cmds[$line]
		cmds=( "${cmds[@]}" )
		break
	    fi
	    if [ "$cmd" == "${cmds[$line]}" ]; then
                ordered_cmds=( "${ordered_cmds[@]}" "${cmds[$line]}" )
                unset cmds[$line]
		cmds=( "${cmds[@]}" )
		break
            fi
        done
    done
    # then the remaining unordered commands:
    ordered_cmds=( "${ordered_cmds[@]}" "${cmds[@]}" )

    # concatenate all commands
    for cmd in ${ordered_cmds[@]}; do
	if [ "$cmd" != "" ]; then
	    cat "$CMDHOOKSDIR/$cmdtype.$cmd.conf" >> "$cmdfile"
	    echo "" >> "$cmdfile"
	fi
    done 
}
